// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockProjectVariables is an autogenerated mock type for the ProjectVariables type
type MockProjectVariables struct {
	mock.Mock
}

// CreateProjectVariable provides a mock function with given fields: ctx, variable
func (_m *MockProjectVariables) CreateProjectVariable(ctx context.Context, variable *models.ProjectVariable) (*models.ProjectVariable, error) {
	ret := _m.Called(ctx, variable)

	if len(ret) == 0 {
		panic("no return value specified for CreateProjectVariable")
	}

	var r0 *models.ProjectVariable
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.ProjectVariable) (*models.ProjectVariable, error)); ok {
		return rf(ctx, variable)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.ProjectVariable) *models.ProjectVariable); ok {
		r0 = rf(ctx, variable)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.ProjectVariable)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.ProjectVariable) error); ok {
		r1 = rf(ctx, variable)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteProjectVariable provides a mock function with given fields: ctx, variable
func (_m *MockProjectVariables) DeleteProjectVariable(ctx context.Context, variable *models.ProjectVariable) error {
	ret := _m.Called(ctx, variable)

	if len(ret) == 0 {
		panic("no return value specified for DeleteProjectVariable")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.ProjectVariable) error); ok {
		r0 = rf(ctx, variable)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetProjectVariableByID provides a mock function with given fields: ctx, id
func (_m *MockProjectVariables) GetProjectVariableByID(ctx context.Context, id string) (*models.ProjectVariable, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetProjectVariableByID")
	}

	var r0 *models.ProjectVariable
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.ProjectVariable, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.ProjectVariable); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.ProjectVariable)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetProjectVariableByPRN provides a mock function with given fields: ctx, prn
func (_m *MockProjectVariables) GetProjectVariableByPRN(ctx context.Context, prn string) (*models.ProjectVariable, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetProjectVariableByPRN")
	}

	var r0 *models.ProjectVariable
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.ProjectVariable, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.ProjectVariable); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.ProjectVariable)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetProjectVariables provides a mock function with given fields: ctx, input
func (_m *MockProjectVariables) GetProjectVariables(ctx context.Context, input *GetProjectVariablesInput) (*ProjectVariablesResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetProjectVariables")
	}

	var r0 *ProjectVariablesResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetProjectVariablesInput) (*ProjectVariablesResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetProjectVariablesInput) *ProjectVariablesResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*ProjectVariablesResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetProjectVariablesInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockProjectVariables creates a new instance of MockProjectVariables. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockProjectVariables(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockProjectVariables {
	mock := &MockProjectVariables{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
